
KMDoc.module({
    name: 'autolink',
    options: {
        template: _.template('<a class="autolink" href="#<%-id%>"><%=text%></a>')
    },
    init: function(options) {
    	// TODO: use workers or batching so we do not block main thread

    	var idx = {};

		_.each(KMDoc.definitions, function(def) {
			var keys = [(def.name.split(' ')[0]).toLowerCase()];
			def.symbol && keys.push(def.symbol);
			def.symbols && (keys = keys.concat(def.symbols));
			def.alias && keys.push(def.alias);
			def.aliases && (keys = keys.concat(def.aliases));

			_.each(keys, function(key) {
				if (key in idx) {
					idx[key].push(def);
				} else {
					idx[key] = [def];
				}	
			})
			
		});

		_.each(idx, function(arr) {
			arr.sort(function(a,b) {
				return b.name.length - a.name.length;
			});
		});

		var autolink = function(txt) {
			return txt.replace(/[^ ]+/g, function(m) {
				var key = m.toLowerCase();
				if (key in idx) {
					var arr = idx[key];
					for (var i = 0; i < arr.length; i+=1) {
						// TODO: lookahead
						//if (arr[i].name.toLowerCase() === key) {
							return options.template({
								id: arr[i].id,
								text: m
							});
						//}
					}
				}
				return m;
			});
		}

		var autoElement = function(el) {
			var $this = $(el);
			var str = $this.html();
			var strNew = autolink(str);
			if (str !== strNew) {
				$this.html(strNew);
			}
		}

		$('.definition dd').each(function() {
			autoElement(this);
		});

		$('.section>*:not(.definition,h1,h2,h3,h4,h5,h6)').each(function() {
			autoElement(this);
		});

    }
});